(function()
{
    angular.module('appSdk')
        .factory('WeeksBusiness', ['WeeksDataAccess', '$q', function (WeeksDataAccess, $q) {

            var Business = {};

            Business.formatWeek = function(data)
            {
                data.DayList.forEach(function(day) {
                    day.CourseList.forEach(function (course) {
                        var dt = new Date(course.BeginDate);
                        var secs = dt.getSeconds() + (60 * dt.getMinutes()) + (60 * 60 * dt.getHours());
                        course.BeginPercent = secs / (60 * 60 * 24) * 100;
                        course.BeginSeconds = secs;

                        dt = new Date(course.EndDate);
                        secs = dt.getSeconds() + (60 * dt.getMinutes()) + (60 * 60 * dt.getHours());
                        course.EndPercent = secs / (60 * 60 * 24) * 100;
                        course.EndSeconds = secs;
                    });
                });
            };

            Business.getWeek = function(data, promise)
            {
                var defer = $q.defer();
                WeeksDataAccess.getWeek(data, promise)
                    .then(function(data)
                    {
                        Business.formatWeek(data);
                        defer.resolve(data);
                    }, defer.reject);
                return defer.promise;
            };

            Business.getCurrentWeek = function(data, promise)
            {
                var defer = $q.defer();
                WeeksDataAccess.getCurrentWeek(data, promise)
                    .then(function(data)
                    {
                        Business.formatWeek(data);
                        defer.resolve(data);
                    }, defer.reject);
                return defer.promise;
            };

            return Business;
        }]);
})();